---
title: Node.hasChildNodes()
slug: Web/API/Node/hasChildNodes
tags:
  - API
  - DOM
  - Method
  - NeedsSpecTable
  - Node
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>Node.hasChildNodes()</strong></code> method returns a {{jsxref("Boolean")}} value indicating whether the given {{domxref("Node")}} has <a href="/en-US/docs/Web/API/Node.childNodes" title="DOM/Node.childNodes">child nodes</a> or not.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>bool</em> = <em>node</em>.hasChildNodes();</pre>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Boolean")}} that is <code>true</code> if the node has child nodes, and <code>false</code> otherwise.</p>

<h2 id="Example">Example</h2>

<pre class="brush:js">let foo = document.getElementById('foo');

if (foo.hasChildNodes()) {
  // Do something with 'foo.childNodes'
}
</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>Here is one possible polyfill:</p>

<pre class="brush:js">;(function(prototype) {
  prototype.hasChildNodes = prototype.hasChildNodes || function() {
    return !!this.firstChild;
  }
})(Node.prototype);
</pre>

<p>There are various ways to determine whether the node has a child node:</p>

<ul>
 <li><code>node.hasChildNodes()</code></li>
 <li><code>node.firstChild != null</code> (or just <code>node.firstChild</code>)</li>
 <li><code>node.childNodes &amp;&amp; node.childNodes.length</code> (or <code>node.childNodes.length &gt; 0</code>)</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-node-haschildnodes", "Node: hasChildNodes")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Node.hasChildNodes")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Node.childNodes")}}</li>
 <li>{{domxref("Node.hasAttributes")}}</li>
</ul>
